Index: her-projects/maori-lang-detection/conf/config.properties
===================================================================
--- /other-projects/maori-lang-detection/conf/config.properties	(revision 33642)
+++ 	(revision )
@@ -1,31 +1,0 @@
-# https://www.linuxjournal.com/content/downloading-entire-web-site-wget
-# https://linuxreviews.org/Wget:_download_whole_or_parts_of_websites_with_ease
-# https://www.webhostface.com/kb/knowledgebase/examples-using-wget/
-# "You can replicate the HTML content of a website with the âmirror option (or -m for short)
-#       wget -m http://domain.com"
-# https://www.linuxquestions.org/questions/linux-server-73/wget-how-to-download-more-than-one-file-at-once-instead-of-file-after-file-704693/
-wget.mirror.cmd=wget -Q10m -m %%BASE_URL%%
-
-# for downloading a single file
-wget.file.cmd=wget %%FILE_URL%%
-
-# Arbitrary cutoff values for WETProcessor.java
-WETprocessor.min.content.length=100
-WETprocessor.min.line.count=2
-WETprocessor.min.content.length.wrapped.line=500
-WETprocessor.min.spaces.per.wrapped.line=10
-
-# Arbitrary cutoff values for WETProcessor.java
-# for determining whether a WET record has sufficient and sensible content
-WETprocessor.max.word.length=15
-WETprocessor.min.num.words=20
-WETprocessor.max.words.camelcase=10
-
-
-mongodb.user=anupama
-mongodb.pwd=chang3m3
-# default mongodb port is 27017. Don't change the port unless you really have configured
-# your mongodb server to listen at some other port
-mongodb.port=27017
-mongodb.host=mongodb.cms.waikato.ac.nz
-mongodb.dbname=ateacrawldata
Index: /other-projects/maori-lang-detection/conf/config.properties.in
===================================================================
--- /other-projects/maori-lang-detection/conf/config.properties.in	(revision 33643)
+++ /other-projects/maori-lang-detection/conf/config.properties.in	(revision 33643)
@@ -0,0 +1,32 @@
+# https://www.linuxjournal.com/content/downloading-entire-web-site-wget
+# https://linuxreviews.org/Wget:_download_whole_or_parts_of_websites_with_ease
+# https://www.webhostface.com/kb/knowledgebase/examples-using-wget/
+# "You can replicate the HTML content of a website with the âmirror option (or -m for short)
+#       wget -m http://domain.com"
+# https://www.linuxquestions.org/questions/linux-server-73/wget-how-to-download-more-than-one-file-at-once-instead-of-file-after-file-704693/
+wget.mirror.cmd=wget -Q10m -m %%BASE_URL%%
+
+# for downloading a single file
+wget.file.cmd=wget %%FILE_URL%%
+
+# Arbitrary cutoff values for WETProcessor.java
+WETprocessor.min.content.length=100
+WETprocessor.min.line.count=2
+WETprocessor.min.content.length.wrapped.line=500
+WETprocessor.min.spaces.per.wrapped.line=10
+
+# Arbitrary cutoff values for WETProcessor.java
+# for determining whether a WET record has sufficient and sensible content
+WETprocessor.max.word.length=15
+WETprocessor.min.num.words=20
+WETprocessor.max.words.camelcase=10
+
+
+mongodb.user=anupama
+mongodb.pwd=chang3m3
+# default mongodb port is 27017. Don't change the port unless you really have configured
+# your mongodb server to listen at some other port
+mongodb.port=27017
+mongodb.host=mongodb.cms.waikato.ac.nz
+#mongodb.dbname=ateacrawldata
+mongodb.dbname=anupama
Index: her-projects/maori-lang-detection/conf/log4j.properties
===================================================================
--- /other-projects/maori-lang-detection/conf/log4j.properties	(revision 33642)
+++ 	(revision )
@@ -1,48 +1,0 @@
-# See for basic example https://stackoverflow.com/questions/125 32339/no-appenders-could-be-found-for-loggerlog4j
-# For better examples, see /greenstone/greenstone3/web/WEB-INF/classes/log4j.properties
-# Manual (examples use XML versions of log4j config files): https://logging.apache.org/log4j/2.x/manual/configuration.html
-# https://logging.apache.org/log4j/2.x/manual/configuration.html#Properties
-# HH (0-24 hrs) vs hh (0-12 hrs, am/pm): https://docs.oracle.com/javase/7/docs/api/java/text/SimpleDateFormat.html
-# https://logging.apache.org/log4j/1.2/manual.html
-####################### 
-
-# define some reusable properties
-maori-lang-detector.home=/Scratch/ak19/gs3-extensions/maori-lang-detection
-maori-lang-detector.logpath=${maori-lang-detector.home}/logs
-
-# Let's log everything from the most basic DEBUG msgs on (so INFO, WARN, ERROR too)
-# Also want to log to the console, see
-# https://stackoverflow.com/questions/3382985/how-to-make-log4j-to-write-to-the-console-as-well
-
-log4j.rootCategory=DEBUG, console, mldlog
-
-# Define Console Appender
-log4j.appender.console=org.apache.log4j.ConsoleAppender
-# Define the layout for console appender. If you do not define it, you will get an error
-log4j.appender.console.layout=org.apache.log4j.PatternLayout
-log4j.appender.console.Target=System.err
-
-# We're saying our log "mldlog" is some file that gets appended to,
-# and it will write it out to "maori-lang-detector.log" located in whatever we defined the "logpath" to be
-
-# Old way of logging:
-#log4j.appender.mldlog=org.apache.log4j.RollingFileAppender
-#log4j.appender.mldlog.File=${maori-lang-detector.logpath}/maori-lang-detector.log
-## https://howtodoinjava.com/log4j/log4j-rolling-file-appender/
-##log4j.appender.mldlog.MaxBackupIndex=10
-
-# We want a DailyRollingFileAppender.
-# Its behaviour is explained at
-# https://examples.javacodegeeks.com/enterprise-java/log4j/log4j-rolling-daily-file-example/
-log4j.appender.mldlog=org.apache.log4j.DailyRollingFileAppender
-log4j.appender.mldlog.File=${maori-lang-detector.logpath}/maori-lang-detector.log
-log4j.appender.mldlog.DatePattern='.'yyyy-MM-dd
-	# set to roll over every day, can change this to weekly/every min etc, see https://logging.apache.org/log4j/1.2/apidocs/org/apache/log4j/DailyRollingFileAppender.html
-
-# if you have more logs, define category, additivity, appender and appender.File for it as above
-# for each log also set the format of the output as below, after setting the layout to use PatternLayout class to parse the format
-
-log4j.appender.mldlog.layout=org.apache.log4j.PatternLayout
-log4j.appender.mldlog.layout.ConversionPattern=%-5p: [%d{yyyy-MM-dd HH:mm:ss}] %C{1}.%M()%n %m%n
-
-#######################
Index: /other-projects/maori-lang-detection/conf/log4j.properties.in
===================================================================
--- /other-projects/maori-lang-detection/conf/log4j.properties.in	(revision 33642)
+++ /other-projects/maori-lang-detection/conf/log4j.properties.in	(revision 33643)
@@ -9,14 +9,17 @@
 # define some reusable properties
 maori-lang-detector.home=@maori-lang-detector.home@
-maori-lang-detector.logpath=${maori-lang-detector.home}/web/logs
+maori-lang-detector.logpath=${maori-lang-detector.home}/logs
 
 # Let's log everything from the most basic DEBUG msgs on (so INFO, WARN, ERROR too)
-log4j.rootCategory=DEBUG, mldlog
+# Also want to log to the console, see
+# https://stackoverflow.com/questions/3382985/how-to-make-log4j-to-write-to-the-console-as-well
 
-# copied from GS3
-log4j.category.web.servlets.DirectInput=INFO, mldlog
-# Prevent logging duplicating its messages into rootLogger:
-# https://stackoverflow.com/questions/9208710/java-log4j-log-to-both-category-and-root-logger
-log4j.additivity.web.servlets.DirectInput=false
+log4j.rootCategory=DEBUG, console, mldlog
+
+# Define Console Appender
+log4j.appender.console=org.apache.log4j.ConsoleAppender
+# Define the layout for console appender. If you do not define it, you will get an error
+log4j.appender.console.layout=org.apache.log4j.PatternLayout
+log4j.appender.console.Target=System.err
 
 # We're saying our log "mldlog" is some file that gets appended to,