Index: /main/trunk/greenstone3/web/WEB-INF/classes/interface_default2.properties
===================================================================
--- /main/trunk/greenstone3/web/WEB-INF/classes/interface_default2.properties	(revision 33647)
+++ /main/trunk/greenstone3/web/WEB-INF/classes/interface_default2.properties	(revision 33648)
@@ -105,11 +105,21 @@
 debuginfo.oaiserver=oaiserver servlet
 debuginfo.intermediateview=Viewing intermediate stages of page preparation
-debuginfo.usage=When debugging the XSLT, you can append any of the following to the URL (prefixed with a & or ? as appropriate) to see the intermediate XML that's produced.
-debuginfo.xml=Displays the raw XML information coming from the Message Router.
-debuginfo.xmlfinal=Displays the information coming from the Message Router after the second config_format pass.
-debuginfo.skindoc=Simplified Skin XSL with Expanded GSF statements appended.
-debuginfo.skinandlib=An XML document with a root element called skinAndLibraryXsl and the two children skinXsl and libraryXsl. The libraryXsl, which already includes util.xsl, is merely appended.
-debuginfo.skinandlibdoc=The result of applying preprocess.xsl to skinandlib produces this stylesheet. 
-debuginfo.skinandlibdocfinal=This one actually is the final XSLT document. The result of applying config_format.xsl and text_fragment_format.xsl to skinandlibdoc. This is the XSLT document that will be applied to the XML data returned from the message router.
+debuginfo.intview_desc=To make the HTML page, we produce a page of XML with all the content in it. That gets transformed by XSLT to produce the HTML output.
+debuginfo.usage=When debugging the HTML page generation process, you can append any of the following to the URL (prefixed with a & or ? as appropriate) to see the intermediate stages of page production.
+debuginfo.xml=Displays the page XML.
+debuginfo.format=Displays the format statements extracted from the page XML and converted into proper XSL  - i.e. all GSF elements converted to XSL.
+debuginfo.format1=Displays the raw format statements extracted from the page XML. These are the format options and templates that come from configuration files (collection, site etc). 
+debuginfo.ilt=Displays the inline template that was sent as a cgi argument (ilt=). Inline templates are used in ajax calls when we only want part of the page returned - e.g. for dynamically loading one section of a document.
+debuginfo.gslib=Displays the gslib XSL, after includes/imports have been added.
+debuginfo.gslib1=Displays the gslib XSL, before includes/imports have been added.
+debuginfo.expandgslib=Displays the expand-gslib XSL (that is used to merge the gslib with the main page XSL)
+debuginfo.xsl=The final XSL that will be used to transform the page XML. Format elements and inline templates have been added in, with any include/import files inlined. gslib and gsf elements have been transformed to proper XSL. 
+debuginfo.xsl1=The original page XSL (eg pages/about.xsl) - generated by merging all inheriting variants of the file. We look for the file in base interface, current interface, site, collection, with templates from the latter overriding the former.
+debuginfo.xsl2=The page XSL with format elements (options and templates from the collection/site configuration files) added in.
+debuginfo.xsl3=The page XSL with format elements and inline templates added in. Inline templates are XSL fragments sent as the ilt cgi argument.
+debuginfo.xsl4=The page XSL with format elements and inline templates added in, with any include/import files inlined.
+debuginfo.xsl5=The page XSL with gslib attached, in pageAndGslibXSL document. Ready for processing by expand-gslib.xsl.
+debuginfo.xsl6=The page XSL with format elements and inline templates added in, with any include/import files inlined. gslib elements have been transformed to proper XSL.
+debuginfo.xsl7=The page XSL with format elements and inline templates added in, with any include/import files inlined. gslib elements have been transformed to proper XSL. The first pass of transforming GSF elements to XSL has been done. 
 debuginfo.formatedit=Web interface editor for editing Greenstone3 format statements.
 debuginfo.refreshconfig=Refresh all the collection configuration files:
Index: /main/trunk/greenstone3/web/interfaces/default/transform/pages/debuginfo.xsl
===================================================================
--- /main/trunk/greenstone3/web/interfaces/default/transform/pages/debuginfo.xsl	(revision 33647)
+++ /main/trunk/greenstone3/web/interfaces/default/transform/pages/debuginfo.xsl	(revision 33648)
@@ -27,4 +27,7 @@
     <h2><xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.library')"/></h2>
     <p>
+      <xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.intview_desc')"/>
+    </p>
+    <p>
       <xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.usage')"/>
     </p>
@@ -36,28 +39,49 @@
 	<xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.xml')"/>
       </dd>
-      <dt>o=xmlfinal</dt>
+      <dt>o=xsl</dt>
       <dd>
-	<xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.xmlfinal')"/>
+	<xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.xsl')"/>
+	<dl>
+	  <dt>o=xsl7</dt>
+	  <dd><xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.xsl7')"/></dd>
+	  <dt>o=xsl6</dt>
+	  <dd><xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.xsl6')"/></dd>
+	  <dt>o=xsl5</dt>
+	  <dd><xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.xsl5')"/></dd>
+	  <dt>o=xsl4</dt>
+	  <dd><xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.xsl4')"/></dd>
+	  <dt>o=xsl3</dt>
+	  <dd><xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.xsl3')"/></dd>
+	  <dt>o=xsl2</dt>
+	  <dd><xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.xsl2')"/></dd>
+	  <dt>o=xsl1</dt>
+	  <dd><xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.xsl1')"/></dd>
+	</dl>
       </dd>
-      <dt>o=skinandlibdocfinal</dt>
+      <dt>o=format</dt>
       <dd>
-	<xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.skinandlibdocfinal')"/>
+	<xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.format')"/>
+	<dl>
+	<dt>o=format1</dt>
+	<dd><xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.format1')"/></dd>
+	</dl>
       </dd>
-      <dt>o=skindoc</dt>
+      <dt>o=ilt</dt>
       <dd>
-	<xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.skindoc')"/>
+	<xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.ilt')"/>
       </dd>
-      <dt>o=skinandlib</dt>
+      <dt>o=gslib</dt>
       <dd>
-	<xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.skinandlib')"/>
+	<xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.gslib')"/>
+	<dl>
+	<dt>o=gslib1</dt>
+	<dd><xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.gslib1')"/></dd>
+	</dl>
       </dd>
-      <dt>o=skinandlibdoc</dt>
+      <dt>o=gslib-expander</dt>
       <dd>
-	<xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.skinandlibdoc')"/>
+	<xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.expandgslib')"/>
       </dd>
-      <dt>formatedit=on</dt>
-      <dd>
-	<xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.formatedit')"/>
-      </dd>
+
     </dl>
 
@@ -92,10 +116,12 @@
 	<xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.inlinetemplate')"/>
       </dd>
-    </dl>
-    <dl>
       <dt>dmd=
       </dt>
       <dd>
 	<xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.displaymetadata')"/>
+      </dd>
+      <dt>formatedit=on</dt>
+      <dd>
+	<xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.formatedit')"/>
       </dd>
     </dl>
@@ -109,4 +135,5 @@
 	<xsl:value-of select="util:getInterfaceText($debug_property_file, /page/@lang, 'debuginfo.depositor')"/>
       </dd>
+
     </dl>
     